#!/bin/sh
# Skript na odesilani konfiguracnich sms pres seriovy modem telefonu pomoci WAP-PUSH a OMA
# VYZADUJE - xml2wbxml utilitu z libwbxml, pozor, na DEBIANu neni(ani po pridani baliku)! Nutne zkompilovat ze zdrojaku
#	   - openssl
#	   - bash + printf, grep, echo, awk, tr, hexdump, wc, sed, od, cut, sleep, dd   
#
# TODO - kontrolu, ze sms byla opravdu odeslana
#      - zmenu (zvysovani) id zpravy (iei2_ref_num)
#      - moznost zpracovavat tel cisla delky != 12
#      - zprava, ktera se vleze do 1 sms
#      - vstupni parametry
#      - code sweap :), double check

send_sms() {
	if [ $# -ne 2 ]; then echo "Funkce musi mit parametr" && exit; fi 

	local data=`echo -ne $1 | tr "[:lower:]" "[:upper:]"` 
	local data_len=$2

	[ ! -z $debug ] && echo $data

	echo -ne "AT+CMGS=$data_len\r\n" > $device 		# AT+CMGS=<delka_sms> prikaz pro odeslani sms, telefon pote ceka na data
	sleep 1
	if [ -z $debug_nosend ] 
	then
		echo "odesilam"
		echo -ne "$data\032\r\n" > $device 		# odesilana data, musi koncit znakem /032=CTRL+Z
		sleep 10			 		# empiricka hodnota, ktera stacila k tomu, aby sms byla odeslana, jinak nekdy +CMS ERROR:103
	else 
		echo "neodesilam"
		echo -ne "\032\r\n" > $device			# simulace odeslani dat
	fi

}

add_pdu_head() {
	#VSECHNY HODNOTY JSOU UVEDENE HEXADECIMALNE A KAZDA HODNOTA MUSI MIT 2 ZNAKY (NAPR. 0A) !!!
	if [ $# -ne 2 ]; then echo "Funkce musi mit parametry - cislo prijemce, odesilana data" && exit; fi 

	local data=$1
	local num=$2

	smsc_len=00	   	# pouzit default v telefonu
	submit_opt=51  		# 0x40 = UDH, 0x10 = TTL je relativni, 0x01 = typ zpravy je SMS-Submit
	msg_ref_num=00	 	# 0x00 = nastavuje telefon
	addr_len=0C		# delka telefonniho cisla (uvazujeme mezinarodni format +420.....)
	addr_type=91		# typ addresy je telefonni cislo v mezinarodnim formatu
	addr=$num		# tel cislo s prohozenymi byte
	msg_protocol=00		# SME-to-SME implicitni
	msg_encoding=F5		# 0xF0+0x01 = ME speficika zprava , 0x04 = 8bit kodovani obsahu | udelat pokus, jestli 0xF0 zobrazi konf. sms pouze na display
	msg_ttl=AA		# TTL, AA=4dny
	
	pdu_head=$smsc_len$submit_opt			# posklada pdu hlavicku
	pdu_head=$pdu_head$msg_ref_num$addr_len
	pdu_head=$pdu_head$addr_type$addr
	pdu_head=$pdu_head$msg_protocol$msg_encoding
	pdu_head=$pdu_head$msg_ttl

	data_len=`echo $data | wc -c`			# delka datove casti
	msg_len=`printf %0X $(($data_len / 2))`

	pdu_head=$pdu_head$msg_len

	local sms=$pdu_head$data	
	echo -ne $sms
}

add_udh_head() {
	#VSECHNY HODNOTY JSOU UVEDENE HEXADECIMALNE A KAZDA HODNOTA MUSI MIT 2 ZNAKY (NAPR. 0A) !!!
	if [ $# -ne 2 ]; then echo "Funkce musi mit parametr - wsp data a tel.cislo" && exit; fi 
	local data=$1
	local tel=`echo -ne $2 | cut -d"+" -f 2-| dd conv=swab status=noxfer`	# telefonni cislo, nutne prohodit byte 

	local data_len=`awk "BEGIN {print(length(\"$data\")/2)}"`		# delka datove casti, deli se 2, protoze uzitecna cast sms (bez hlavicek) je 133 wordu!

	#### Information Element Identifier (IEI) 1
	iei1_type=05		# application port addressing scheme,16-bit port address
	iei1_len=04		# delka IEI1 
	iei1_dst_h=0B		# cilovy port, je dulezite zvolit podle typu aplikace, obecny wap-push ma 0x0B84
	iei1_dst_l=84
	iei1_src_h=00		# vychozi port,  nasem pripade neni dulezite, takze staci 0x0000
	iei1_src_l=00
	
	if [ $data_len -gt 133 ]	# !!! ZJISTIT celkovou delku sms !!!
	then
		# musime rozdelit data do vic sms 
		udh_len=0B		# delka hlavicky, IEI1+IEI2

		#### Information Element Identifier (IEI) 2 
		iei2_type=00								# urcuje, ze zprava je rozlozena do vice sms (concated sms)
		iei2_len=03								# delka IEI2
		iei2_ref_num=62								# id sms, v nasem pripade neni dulezite, takze staci 0x44
		iei2_msg_total=`awk "BEGIN {x=$data_len/128;print( x==int(x)?x:int(x)+1)}"`	# celkovy pocet sms (uzitecna cast sms je 128. Je to 133 - 5(IEI2) = 128)
		iei2_msg_total_h=`awk "BEGIN {x=$data_len/128;printf(\"%02d\", x==int(x)?x:int(x)+1)}"`	# celkovy pocet sms (uzitecna cast sms je 128. Je to 133 - 5(IEI2) = 128)
		iei2_msg_num=01								# poradove cislo teto konkretni sms

		udh=$udh_len								# vytvori spolecnou cast udh hlavicky (bez poctu zprav)
		udh=$udh$iei1_type$iei1_len
		udh=$udh$iei1_dst_h$iei1_dst_l
		udh=$udh$iei1_src_h$iei1_src_l
		udh=$udh$iei2_type$iei2_len
		udh=$udh$iei2_ref_num$iei2_msg_total_h

		while [ $iei2_msg_num -le  $(($iei2_msg_total)) ]
		do
			range_l=`echo "($iei2_msg_num - 1)*2*128+1" | bc -l`			# 128 je delka zpravy ve wordech, *2 protoze jsou to byte, +1 protoze cut zacina od 1	
			range_h=`echo "($iei2_msg_num )*2*128" | bc -l`				# 128 je delka zpravy ve wordech, *2 protoze jsou to byte, 	
			[ $range_h -gt $(($data_len*2)) ] && range_h=$(($data_len*2))		# pokud horni meze vetsi nez delka zpravy, zmen horni mez na delku zpravy

			udh_loc=$udh`printf %02d $iei2_msg_num`					# udh hlavicka pro konkretni zpravu 
			
			msg_subp=`echo -ne $data | cut -b$range_l-$range_h`			# vyrizne podcast zpravy

			udh_msg=$udh_loc$msg_subp						# udh hlavicka + zprava	

			sms=`add_pdu_head $udh_msg $tel` 					# pdu hlavicka + udh hlavicka + zprava 

			sms_len=`echo -ne $sms | wc -c `					# celkova delka zpravy, potrebne pro odeslani prikazem CMGS
			sms_len=$(($sms_len / 2 - 1 ))

			send_sms $sms $sms_len							# odesle zpravu

			iei2_msg_num=$(($iei2_msg_num + 1))					# pocitatel zprav + 1
		done	

	else
		# data se nam vlezou do 1 sms
		udh_len=06	# delka hlavicky, IEI1
	fi
}

add_wsp_head() {
	#VSECHNY HODNOTY JSOU UVEDENE HEXADECIMALNE A KAZDA HODNOTA MUSI MIT 2 ZNAKY (NAPR. 0A) !!!
	if [ $# -ne 2 ]; then echo "Funkce musi mit 2 parametry - konfiguracni soubor a klic" && exit; fi 
	
	local xml=$1
	local key=$2

	local data=`xml2wbxml -o - $xml | hexdump -ve '1/1 "%02X"'`		# prevedeni konfiguracniho souboru z xml do wbxml a nasledne do hexadecimalniho tvaru 

	push_id=01		# ID = 1 
	pdu_type=06		# pdu je typu WAP-PUSH
	hdr_len=2F 		# urcuje celkovou delku hlavicky, normalne nutne vzdy znovu vypocitat. My tady mame hlavicku statickou (2+1+2+41+1=47 -> 0x2F) 
	#### 1. prvek hlavicky
	hdr1_type=1F		# prvek hlavicky - delka vsech prvku hlavicky, bez tohoto prvku 
	hdr1_cont=2D		# normalne nutno pokazde vypocitat, my mame hlavicka statickou. (1+2+41+1=45 -> 0x2D)
	#### 2. prvek hlavicky
	hdr2_type=B6		# typ aplikace je application/vnd.wap.connectivity-wbxml, pro tu je WINA kod 36, protoze se to ale koduje jako short int, tak se musi nastavit 7.bit => B6
	#### 3. prvek hlavicky
	hdr3_type=91		# SEC parametr, pro typ B6 povinny, urcuje typ zabezpeceni. Nezakodovana hodnota 11, jako short int => 91
	hdr3_cont=81		# typ zabezpeceni USERPIN. Nezakodovana hodnota = 1, jako short int => 81
	#### 4. prvek hlavicky	
	hdr4_type=92		# MAC parametr, pro typ B6 povinny. Nezakodovana hodnota 12, jako short int => 92
	hash_tmp=`xml2wbxml -o - $xml | openssl dgst -sha1 -hmac $key` 	# hash hodnota pro data s klicem $key (40byte)
	
	hdr4_cont=`echo -ne $hash_tmp |  tr "[:lower:]" "[:upper:]" | od -t x1 -A n | tr "\n" " " | sed s/" "//g` 	# prevede kazdou hexa cislici na jeji ascii hodnotu v HEXA!!! (prevadi z uppercase) 

	hdr_separator=00	# ukoncuje hlavicku (00 = EOF)

	msg=$push_id		# posklada dohromady wsp hlavicku a data
	msg=$msg$pdu_type
	msg=$msg$hdr_len
	msg=$msg$hdr1_type$hdr1_cont
	msg=$msg$hdr2_type
	msg=$msg$hdr3_type$hdr3_cont
	msg=$msg$hdr4_type$hdr4_cont
	msg=$msg$hdr_separator$data

	echo -ne $msg		# return $msg
}

setup_device () {
	if [ $# -ne 1 ]; then echo "Funkce musi mit 1 parametr - zarizeni" && exit; fi 

	local device=$1

	echo -ne "\032\r\nATZ\r\n" > $device		# Reset zarizeni 
	sleep 1
	echo -ne "ATE0\r\n" > $device			# ATE0 potlaci opakovani zadanych prikazu 
	sleep 1
	echo -ne "AT+CMGF=0\r\n" > $device 		# AT+CMGF=0 sms jsou v PDU formatu
	sleep 1
}

#### MAIN ####

device=/dev/ttyACM0
key="1234"
xml_file=edu.xml
tel_num=+420xxxxxxxxx
debug=1
#debug_nosend=1


[ -z `echo $tel_num | grep -o "^+[0-9]\{12\}$"` ] && echo "Spatne telefonni cislo, prosim pouzijte format +420xxxxxxxxx" && exit
[ -z `echo $key | grep -o "^[0-9]\{4,10\}$"` ] && echo "Spatne zadany pin, prosim pouzijte cele cislo od 4-12 cifer" && exit
[ ! -f $xml_file ] && echo "Spatne zadany konfiguracni soubor, ujistete se soubor existuje" && exit
[ ! -c $device ] && echo "Spatne zadane vystupni zarizeni" && exit
[ ! -z $debug_nosend ] && echo "Debug mod - sms nejsou odeslany!!!"

setup_device $device
wsp_data=`add_wsp_head $xml_file $key`
add_udh_head $wsp_data $tel_num 
